; Volume shadow copy creator for Windows 7
; Version 1.0 by Vortex

; Project built with Solar Assembler version 0.35.01

include vscopy.inc

.data

f1                  db 'Volume shadow copy path = %s',13,10,0
f2                  db '%s\',0
f3                  db 13,10,"Snapshot release status = 0x%X",0
f4                  db 'Volume shadow could not be created - %s error = 0x%X',0
a1                  db 'CreateVssBackupComponents',0
a2                  db 'InitializeForBackup',0
a3                  db 'SetBackupState',0
a4                  db 'GatherWriterMetadata',0
a5                  db 'IVssAsync',0
a6                  db 'StartSnapshotSet',0
a7                  db 'AddToSnapshotSet',0
a8                  db 'PrepareForBackup',0
a9                  db 'DoSnapshotSet',0
a10                 db 'GetSnapshotProperties',0
welcome             db 'Volume shadow copy creator for Windows 7',13,10
                    db 'Version 1.0 by Vortex',13,10,13,10
                    db 'Usage : vscopy <volume_letter> <assigned_letter> <file_to_execute>',13,10,0
.data?

pBackupComponent    dd ?
pIVssAsyncA         dd ?
pIVssAsyncB         dd ?
pPrepare            dd ?
pDeletedSnapShot    dd ?
pSnapShotSetId      rs GUID,1
pSnapShotId         rs GUID,1
pNonDelSnapShotId   rs GUID,1
pSnapShotProp       rs VSS_SNAPSHOT_PROP,1
buffer              rb 64
buffer2             rb 256
CmdLine             rb 512

SIZE_OF_BUFFER      equ 64
NO_TIMEOUT          equ -1

.code

start:

    invoke      mainCRTstartup,CmdLine
    invoke      ExitProcess,0

PROC main

USES esi,edi
ARG argc,argv

    cmp         [argc],NUMB_OF_REQ_CMDLINE_PARAMS   ; = 4
    je          CmdLineParamOK
    invoke      StdOut,welcome
    ret

CmdLineParamOK:
    
; Initialize the COM library 

    invoke      CoInitializeEx,NULL,COINIT_MULTITHREADED

; Register security and sets the default security values for the process

    invoke      CoInitializeSecurity,NULL,-1,NULL,NULL,RPC_C_AUTHN_LEVEL_PKT_PRIVACY,\
                RPC_C_IMP_LEVEL_IDENTIFY,NULL,EOAC_NONE,NULL

; Creates an IVssBackupComponents interface object and returns a pointer to it 

    invoke      CreateVssBackupComponents,pBackupComponent
    mov         edx,a1
    test        eax,eax
    jnz         _error

; Initialize the backup components metadata in preparation for backup

    coinvoke    pBackupComponent,IVssBackupComponents,InitializeForBackup,0
    mov         edx,a2
    test        eax,eax
    jnz         _error

; Define an overall configuration for the backup operation

    coinvoke    pBackupComponent,IVssBackupComponents,SetBackupState,\
                TRUE,TRUE,VSS_BT_FULL,FALSE
                
    mov         edx,a3
    test        eax,eax
    jnz         _error

; Get metadata from writers

    coinvoke    pBackupComponent,IVssBackupComponents,GatherWriterMetadata,pIVssAsyncA
    mov         edx,a4
    test        eax,eax
    jnz         _error

    coinvoke    pIVssAsyncA,IVssAsync,_Wait,INFINITE
    mov         edx,a5
    test        eax,eax
    jnz         _error

    coinvoke    pIVssAsyncA,IVssAsync,Release

; Create a new shadow copy set

    coinvoke    pBackupComponent,IVssBackupComponents,StartSnapshotSet,pSnapShotSetId
    mov         edx,a6
    test        eax,eax
    jnz         _error

    mov         edi,CmdLine

    invoke      wsprintf,buffer2,f2,[edi+4]
    invoke      MultiByteToWideChar,CP_ACP,MB_PRECOMPOSED,buffer2,\
                -1,buffer,SIZE_OF_BUFFER

; Add the volume to the shadow copy set

    coinvoke    pBackupComponent,IVssBackupComponents,AddToSnapshotSet,\
                buffer,0,0,0,0,pSnapShotId
                
    mov         edx,a7
    test        eax,eax
    jnz         _error

; Generate a PrepareForBackup event, signaling writers to prepare for an upcoming backup operation

    coinvoke    pBackupComponent,IVssBackupComponents,PrepareForBackup,pPrepare
    mov         edx,a8
    test        eax,eax
    jnz         _error
    
    coinvoke    pPrepare,IVssAsync,_Wait,INFINITE
    mov         edx,a5
    test        eax,eax
    jnz         _error
    
    coinvoke    pPrepare,IVssAsync,Release

; Commit all shadow copies in this set simultaneously

    coinvoke    pBackupComponent,IVssBackupComponents,DoSnapshotSet,pIVssAsyncB
    mov         edx,a9
    test        eax,eax
    jnz         _error
    
    coinvoke    pIVssAsyncB,IVssAsync,_Wait,INFINITE
    mov         edx,a5
    test        eax,eax
    jnz         _error
    
    coinvoke    pIVssAsyncB,IVssAsync,Release

    mov         esi,pSnapShotId

; Get the properties of the specified shadow copy

    coinvoke    pBackupComponent,IVssBackupComponents,GetSnapshotProperties,\
                [esi],[esi+4],[esi+8],[esi+12],pSnapShotProp

    mov         edx,a10
    test        eax,eax
    jnz         _error
                
    invoke      WideCharToMultiByte,CP_ACP,0,\
                [pSnapShotProp+VSS_SNAPSHOT_PROP.m_pwszSnapshotDeviceObject],\
                -1,buffer,SIZE_OF_BUFFER,0,0
                
    invoke      wsprintf,buffer2,f1,buffer
    invoke      StdOut,buffer2

; Assign a letter to the volume shadow copy path

    invoke      DefineDosDevice,0,[edi+8],buffer

; Run the file pointed by the second cmdline parameter synchronously

    invoke      GShell,[edi+12],NO_TIMEOUT

; Free the contents of the structure pointed by pSnapShotProp

    invoke      VssFreeSnapshotProperties,pSnapShotProp

; Delete the shadow copy

    coinvoke    pBackupComponent,IVssBackupComponents,DeleteSnapshots,\
                [esi],[esi+4],[esi+8],[esi+12],\
                VSS_OBJECT_SNAPSHOT,TRUE,pDeletedSnapShot,pNonDelSnapShotId

    invoke      wsprintf,buffer2,f3,eax

    coinvoke    pBackupComponent,IVssBackupComponents,Release

; Remove the letter pointing the volume shadow copy

    invoke      DefineDosDevice,DDD_REMOVE_DEFINITION,[edi+8],0
    
    jmp         _exit

_error:

    invoke      wsprintf,buffer2,f4,edx,eax

_exit:

    invoke      StdOut,buffer2

    invoke      CoUninitialize
    ret

ENDP

include mainCRTstartup.asm
include GShell.asm
include StdOut.asm

