;------------------------------------------------------------------------------;
; This is a translation of a shell script originally written by Edgar Hansen   ;
; in GoASM code. Masm translation by Paul E. Brennick  <pebrennick@verizon.net>;
;                                                                              ;
; SolAsm translation by Vortex                                                 ;
;                                                                              ;
;                                                                              ;
; Shell:      This function will run an executable and wait until it has       ;
;             finished before continuing. The function provides for a time     ;
;             out for a maximum wait period.                                   ;
; Parameters: lpfilename = The fully qualified path to an executable to run    ;
;             dwTimeOut = The amount of time in milliseconds to wait, -1 for   ;
;             no timeout                                                       ;
; Returns:    0 if successful, STATUS_TIMEOUT if the timeout has elapsed       ;
;             -1 if there was an error creating the process                    ;
;                                                                              ;
;------------------------------------------------------------------------------;

PROC GShell
ARG lpfilename,dwTimeOut

LOCAL Sh_st_info :STARTUPINFO
LOCAL Sh_pr_info :PROCESS_INFORMATION

    mov     DWORD PTR [Sh_st_info.cb],SIZE STARTUPINFO
    invoke  GetStartupInfo,ADDR [Sh_st_info]
    
    mov     DWORD PTR [Sh_st_info.lpReserved],0
    invoke  CreateProcess,0,[lpfilename],0,0,0,0,0,0,\
            ADDR [Sh_st_info],ADDR [Sh_pr_info]
            
    test    eax, eax
    jz      GShell_err
    
    invoke  WaitForSingleObject, [Sh_pr_info.hProcess], [dwTimeOut]
    push    eax
    invoke  CloseHandle,[Sh_pr_info.hThread]
    invoke  CloseHandle,[Sh_pr_info.hProcess]
    pop     eax
    test    eax, eax
    ret
    
GShell_err:

    xor     eax,eax
    sub     eax,1
    ret

ENDP
